#include <sys/types.h>
#include <pthread.h>
#include <iostream>

#define ARRAY_SIZE 10
int array[] = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 };

using namespace std;

void printArray() {
  cout << "[ ";
  for( int x = 0; x < ARRAY_SIZE - 1; x++ ) {
    cout << array[ x ] << ", ";
  }
  cout << array[ ARRAY_SIZE - 1 ] << " ]" << endl;
}

void* addTwo( void* threadId ) {
  int start, end;
  if ( *((int*)threadId) == 0 ) {
    start = 0;
    end = 4;
  } else {
    start = 5;
    end = 9;
  }

  for( int x = start; x <= end; x++ ) {
    array[ x ] += 2;
  }

  return NULL;
}

int main( int argc, char** argv ) {
  pthread_t threads[ 2 ];
  int ids[] = { 0, 1 };
  int createRetval;

  createRetval = pthread_create( &(threads[ 0 ]), 
				 NULL,
				 addTwo,
				 (void*)&(ids[ 0 ]) );
  if ( createRetval ) {
    cout << "Failed to create thread one." << endl;
  }
  createRetval = pthread_create( &(threads[ 1 ]),
				 NULL,
				 addTwo,
				 (void*)&(ids[ 1 ]) );
  if ( createRetval ) {
    cout << "Failed to create thread two." << endl;
  }

  // at this point the threads are running in parallel
  int joinRetval;
  joinRetval = pthread_join( threads[ 0 ], NULL );
  if ( joinRetval ) {
    cout << "Failed to join thread one." << endl;
  }
  
  joinRetval = pthread_join( threads[ 1 ], NULL );
  if ( joinRetval ) {
    cout << "Failed to join thread two." << endl;
  }

  printArray();
  return 0;
}
