#include "sys/types.h"
#include "sys/wait.h"
#include "unistd.h"
#include "stdio.h"

int main( int argc, char** argv ) {
  printf( "Program starting with pid %i\n", getpid() );

  pid_t pid = fork();
  if ( pid < 0 ) {
    printf( "Failed to fork.\n" );
  } else if ( pid == 0 ) {
    printf( "I'm the child process.  My pid is %i.\n", getpid() );
  } else {
    printf( "I'm the parent process with pid %i.  ", getpid() );
    printf( "I spawned a child with pid %i, and I'll wait for it.\n", pid );
    waitpid( pid, NULL, 0 );
  }

  printf( "Program ending with pid %i\n", getpid() );

  return 0;
}
